--[[
    https://gist.github.com/kymckay/25758d37f8e3872e1636d90ad41fe2ed
    Implemented as described here:
    http://flafla2.github.io/2014/08/09/perlinnoise.html
]] --

bit32 = {};
local N = 32;
local P = 2 ^ N;

bit32.bnot = function(x)
    x = x % P;
    return (P - 1) - x;
end;

bit32.band = function(x, y)
    if (y == 255) then return x % 256; end
    if (y == 65535) then return x % 65536; end
    if (y == 4294967295) then return x % 4294967296; end
    x, y = x % P, y % P;
    local r = 0;
    local p = 1;
    for i = 1, N do
        local a, b = x % 2, y % 2;
        x, y = math.floor(x / 2), math.floor(y / 2);
        if ((a + b) == 2) then r = r + p; end
        p = 2 * p;
    end
    return r;
end;

bit32.bor = function(x, y)
    if (y == 255) then return (x - (x % 256)) + 255; end
    if (y == 65535) then return (x - (x % 65536)) + 65535; end
    if (y == 4294967295) then return 4294967295; end
    x, y = x % P, y % P;
    local r = 0;
    local p = 1;
    for i = 1, N do
        local a, b = x % 2, y % 2;
        x, y = math.floor(x / 2), math.floor(y / 2);
        if ((a + b) >= 1) then r = r + p; end
        p = 2 * p;
    end
    return r;
end;

bit32.bxor = function(x, y)
    x, y = x % P, y % P;
    local r = 0;
    local p = 1;
    for i = 1, N do
        local a, b = x % 2, y % 2;
        x, y = math.floor(x / 2), math.floor(y / 2);
        if ((a + b) == 1) then r = r + p; end
        p = 2 * p;
    end
    return r;
end;

bit32.lshift = function(x, s_amount)
    if (math.abs(s_amount) >= N) then return 0; end
    x = x % P;
    if (s_amount < 0) then
        return math.floor(x * (2 ^ s_amount));
    else
        return (x * (2 ^ s_amount)) % P;
    end
end;

bit32.rshift = function(x, s_amount)
    if (math.abs(s_amount) >= N) then return 0; end
    x = x % P;
    if (s_amount > 0) then
        return math.floor(x * (2 ^ -s_amount));
    else
        return (x * (2 ^ -s_amount)) % P;
    end
end;

bit32.arshift = function(x, s_amount)
    if (math.abs(s_amount) >= N) then return 0; end
    x = x % P;
    if (s_amount > 0) then
        local add = 0;
        if (x >= (P / 2)) then
            add = P - (2 ^ (N - s_amount));
        end
        return math.floor(x * (2 ^ -s_amount)) + add;
    else
        return (x * (2 ^ -s_amount)) % P;
    end
end;

bit32.extract = function(n, field, width)
    width = width or 1;
    return (n >> field) & ((1 << width) - 1);
end;

bit32.replace = function(n, v, field, width)
    width = width or 1;
    local mask = ((1 << width) - 1) << field;
    return (n & ~mask) | ((v << field) & mask);
end;

bit32.btest = function(...)
    return bit32.band(...) ~= 0;
end;



--[[
    Implemented as described here:
    http://flafla2.github.io/2014/08/09/perlinnoise.html
]] --

perlin = {}
perlin.p = {}

-- Hash lookup table as defined by Ken Perlin
-- This is a randomly arranged array of all numbers from 0-255 inclusive
local permutation = { 151, 160, 137, 91, 90, 15,
    131, 13, 201, 95, 96, 53, 194, 233, 7, 225, 140, 36, 103, 30, 69, 142, 8, 99, 37, 240, 21, 10, 23,
    190, 6, 148, 247, 120, 234, 75, 0, 26, 197, 62, 94, 252, 219, 203, 117, 35, 11, 32, 57, 177, 33,
    88, 237, 149, 56, 87, 174, 20, 125, 136, 171, 168, 68, 175, 74, 165, 71, 134, 139, 48, 27, 166,
    77, 146, 158, 231, 83, 111, 229, 122, 60, 211, 133, 230, 220, 105, 92, 41, 55, 46, 245, 40, 244,
    102, 143, 54, 65, 25, 63, 161, 1, 216, 80, 73, 209, 76, 132, 187, 208, 89, 18, 169, 200, 196,
    135, 130, 116, 188, 159, 86, 164, 100, 109, 198, 173, 186, 3, 64, 52, 217, 226, 250, 124, 123,
    5, 202, 38, 147, 118, 126, 255, 82, 85, 212, 207, 206, 59, 227, 47, 16, 58, 17, 182, 189, 28, 42,
    223, 183, 170, 213, 119, 248, 152, 2, 44, 154, 163, 70, 221, 153, 101, 155, 167, 43, 172, 9,
    129, 22, 39, 253, 19, 98, 108, 110, 79, 113, 224, 232, 178, 185, 112, 104, 218, 246, 97, 228,
    251, 34, 242, 193, 238, 210, 144, 12, 191, 179, 162, 241, 81, 51, 145, 235, 249, 14, 239, 107,
    49, 192, 214, 31, 181, 199, 106, 157, 184, 84, 204, 176, 115, 121, 50, 45, 127, 4, 150, 254,
    138, 236, 205, 93, 222, 114, 67, 29, 24, 72, 243, 141, 128, 195, 78, 66, 215, 61, 156, 180
}

-- p is used to hash unit cube coordinates to [0, 255]
for i = 0, 255 do
    -- Convert to 0 based index table
    perlin.p[i] = permutation[i + 1]
    -- Repeat the array to avoid buffer overflow in hash function
    perlin.p[i + 256] = permutation[i + 1]
end

-- Return range: [-1, 1]
function perlin:noise(x, y, z)
    y        = y or 0
    z        = z or 0

    -- Calculate the "unit cube" that the point asked will be located in
    local xi = bit32.band(math.floor(x), 255)
    local yi = bit32.band(math.floor(y), 255)
    local zi = bit32.band(math.floor(z), 255)

    -- Next we calculate the location (from 0 to 1) in that cube
    x        = x - math.floor(x)
    y        = y - math.floor(y)
    z        = z - math.floor(z)

    -- We also fade the location to smooth the result
    local u  = self.fade(x)
    local v  = self.fade(y)
    local w  = self.fade(z)

    -- Hash all 8 unit cube coordinates surrounding input coordinate
    local p  = self.p
    local A, AA, AB, AAA, ABA, AAB, ABB, B, BA, BB, BAA, BBA, BAB, BBB
    A        = p[xi] + yi
    AA       = p[A] + zi
    AB       = p[A + 1] + zi
    AAA      = p[AA]
    ABA      = p[AB]
    AAB      = p[AA + 1]
    ABB      = p[AB + 1]

    B        = p[xi + 1] + yi
    BA       = p[B] + zi
    BB       = p[B + 1] + zi
    BAA      = p[BA]
    BBA      = p[BB]
    BAB      = p[BA + 1]
    BBB      = p[BB + 1]

    -- Take the weighted average between all 8 unit cube coordinates
    return self.lerp(w,
        self.lerp(v,
            self.lerp(u,
                self:grad(AAA, x, y, z),
                self:grad(BAA, x - 1, y, z)
            ),
            self.lerp(u,
                self:grad(ABA, x, y - 1, z),
                self:grad(BBA, x - 1, y - 1, z)
            )
        ),
        self.lerp(v,
            self.lerp(u,
                self:grad(AAB, x, y, z - 1), self:grad(BAB, x - 1, y, z - 1)
            ),
            self.lerp(u,
                self:grad(ABB, x, y - 1, z - 1), self:grad(BBB, x - 1, y - 1, z - 1)
            )
        )
    )
end

-- Gradient function finds dot product between pseudorandom gradient vector
-- and the vector from input coordinate to a unit cube vertex
perlin.dot_product = {
    [0x0] = function(x, y, z) return x + y end,
    [0x1] = function(x, y, z) return -x + y end,
    [0x2] = function(x, y, z) return x - y end,
    [0x3] = function(x, y, z) return -x - y end,
    [0x4] = function(x, y, z) return x + z end,
    [0x5] = function(x, y, z) return -x + z end,
    [0x6] = function(x, y, z) return x - z end,
    [0x7] = function(x, y, z) return -x - z end,
    [0x8] = function(x, y, z) return y + z end,
    [0x9] = function(x, y, z) return -y + z end,
    [0xA] = function(x, y, z) return y - z end,
    [0xB] = function(x, y, z) return -y - z end,
    [0xC] = function(x, y, z) return y + x end,
    [0xD] = function(x, y, z) return -y + z end,
    [0xE] = function(x, y, z) return y - x end,
    [0xF] = function(x, y, z) return -y - z end
}
function perlin:grad(hash, x, y, z)
    return self.dot_product[bit32.band(hash, 0xF)](x, y, z)
end

-- Fade function is used to smooth final output
function perlin.fade(t)
    return t * t * t * (t * (t * 6 - 15) + 10)
end

function perlin.lerp(t, a, b)
    return a + t * (b - a)
end

local iterations = 10;
local length = 10;

local screen_size = 800;
local block_count = 10;

local block_size = screen_size / block_count;

config:set_size(screen_size, screen_size)
config:set_background_color(Color(20, 20, 30))
config:set_fps(60)
config:set_num_layers(1)

layer(0)

function Block(x, y, i)
    local pos = Point(x * block_size, y * block_size);
    local size = Size(block_size, block_size);

    local xi = 2 * (x / block_count) - 1;
    local yi = 2 * (y / block_count) - 1;

    local clr_start = perlin:noise(xi, yi, (i) / iterations);
    local clr_end = perlin:noise(xi, yi, (i + 1) / iterations);
    -- local clr_end = clr_start;

    animate(Animation(
        Rect(pos, size, Color(clr_start, clr_start, clr_start)),
        Rect(pos, size, Color(clr_end, clr_end, clr_end)),
        1.0,
        Linear()
    ))
end

for i = 0, iterations do
    for x = 0, block_count - 1 do
        for y = 0, block_count - 1 do
            Block(x, y, i)
        end
    end
    render(1)
end
